private import bogoyaml;
private import util;
private import runner;
private import std.stream;
private import std.string;
private import std.conv;

int main(char[][] args) {
    if (args.length < 2) {
        die("please specify yml file");
    }

    YamlHolder h = bogoyaml.yamlLoad(args[1]);

    auto YamlLangRunner r = new YamlLangRunner(h);

    with (r) {
        r.addBuiltIn(`.print`, delegate YamlHolder () {
            char[] str = bih_getstr(`.msg`);
            std.stream.stdout.writeLine(str);
            return yfalse;
        });
        r.addBuiltIn(`.if`, delegate YamlHolder () {
            char[] cond = bih_getstr(`.cond`);
            if (cond.length > 0) {
                return bih_getres(`.then`);
            }
            else {
                return yfalse;
            }
        });
        r.addBuiltIn(`.nequal`, delegate YamlHolder () {
            char[] lhs = bih_getstr(`.lhs`);
            char[] rhs = bih_getstr(`.rhs`);
            if (lhs != rhs) {
                return ytrue;
            }
            else {
                return yfalse;
            }
        });
        r.addBuiltIn(`.add`, delegate YamlHolder () {
            char[] lhs = bih_getstr(`.lhs`);
            char[] rhs = bih_getstr(`.rhs`);
            return new YamlScalar(std.string.toString(toInt(lhs)+toInt(rhs)));
        });
    }

    r.invokeMsg(`.main`);

    return 0;
}
